Index: kernel/classes/ezcontentclassattribute.php
===================================================================
--- kernel/classes/ezcontentclassattribute.php  (Revision 23511)
+++ kernel/classes/ezcontentclassattribute.php  (Arbeitskopie)
@@ -354,12 +354,15 @@
             $objectList = eZPersistentObject::fetchObjectList( eZContentClassAttribute::definition(),
                                                                 null, $conditions, null, null,
                                                                 $asObject );
-            foreach ( array_keys( $objectList ) as $objectKey )
+            if ( $asObject )
             {
-                $objectItem =& $objectList[$objectKey];
-                $objectID = $objectItem->ID;
-                $objectVersion = $objectItem->Version;
-                $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] =& $objectItem;
+                foreach ( array_keys( $objectList ) as $objectKey )
+                {
+                    $objectItem =& $objectList[$objectKey];
+                    $objectID = $objectItem->ID;
+                    $objectVersion = $objectItem->Version;
+                    $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] =& $objectItem;
+                }
             }
             $objects = $objectList;
         }
@@ -394,7 +397,7 @@
                     $objectID = $objectItem->ID;
                     $objectVersion = $objectItem->Version;
                 }
-                if ( !isset( $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] ) )
+                if ( !isset( $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] ) && $asObject )
                     $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] =& $objectItem;
             }
             $objects = $objectList;
@@ -412,7 +415,7 @@
             $objectItem =& $objectList[$objectKey];
             $objectID = $objectItem->ID;
             $objectVersion = $objectItem->Version;
-            if ( !isset( $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] ) )
+            if ( !isset( $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] ) && $asObject )
                 $GLOBALS['eZContentClassAttributeCache'][$objectID][$objectVersion] =& $objectItem;
         }
         return $objectList;
